import 'package:diameter/main.dart';
import 'package:diameter/models/meal.dart';
import 'package:diameter/models/recipe.dart';
import 'package:objectbox/objectbox.dart';
import 'package:diameter/objectbox.g.dart' show Ingredient_, Recipe_;

@Entity(uid: 6950311793136068892)
@Sync()
class Ingredient {
  static final Box<Ingredient> box = objectBox.store.box<Ingredient>();

  // properties
  int id;
  bool deleted;
  double amount;

  // relations
  final recipe = ToOne<Recipe>();
  final ingredient = ToOne<Meal>();

  // constructor
  Ingredient({
    this.id = 0,
    this.deleted = false,
    required this.amount,
  });

  static List<Ingredient> getAllForRecipe(int id) {
    QueryBuilder<Ingredient> builder = box.query(Ingredient_.deleted.equals(false));
    builder.link(Ingredient_.recipe, Recipe_.id.equals(id));
    return builder.build().find();
  }
}